#include <stdio.h>
#include <ucontext.h>

static ucontext_t ctx_main, ctx_1, ctx_2;

void func1(void)
{
  static int done = 0;
  int value1;

  getcontext(&ctx_1);
  if (done == 0) {
    done = 1;
    return;
  }

  value1 = 1;
  while(1) {
    printf("func1 is running, value1@%p = %d\n", &value1, value1);
    swapcontext(&ctx_1, &ctx_main);
  }
}

void func2(void)
{
  static int done = 0;
  int value2;

  getcontext(&ctx_2);
  if (done == 0) {
    done = 1;
    return;
  }

  value2 = 2;
  while(1) {
    printf("func2 is running, value2@%p = %d\n", &value2, value2);
    swapcontext(&ctx_2, &ctx_main);
  }
}

int main(void)
{
  int c = 0;

  func1();
  func2();

  while(1) {
    if (getchar() == EOF) {
      printf("Exiting\n");
      break;
    }
    c = (c + 1) % 2;
    if (1 == c) {
      swapcontext(&ctx_main, &ctx_1);
    } else {
      swapcontext(&ctx_main, &ctx_2);
    }
  }

  return 0;
}
