#include <stdio.h>
#include <ucontext.h>
#include <stdlib.h>

static ucontext_t ctx_main, ctx_1, ctx_2;

void func1(void)
{
  int value1 = 1;

  while(1) {
    printf("func1 is running, value1@%p = %d\n", &value1, value1);
    swapcontext(&ctx_1, &ctx_main);
  }
}

void func2(void)
{
  int value2 = 2;

  while(1) {
    printf("func2 is running, value2@%p = %d\n", &value2, value2);
    swapcontext(&ctx_2, &ctx_main);
  }
}

int main(void)
{
  int c;
  char *stack1 = malloc(16384);
  char *stack2 = malloc(16384);

  getcontext(&ctx_1);
  ctx_1.uc_stack.ss_sp = stack1;
  ctx_1.uc_stack.ss_size = 16384;
  ctx_1.uc_stack.ss_flags = 0;
  ctx_1.uc_link = 0;
  makecontext(&ctx_1, func1, 0);

  getcontext(&ctx_2);
  ctx_2.uc_stack.ss_sp = stack2;
  ctx_2.uc_stack.ss_size = 16384;
  ctx_2.uc_stack.ss_flags = 0;
  ctx_2.uc_link = 0;
  makecontext(&ctx_2, func2, 0);

  c = 0;
  while(1) {
    if (getchar() == EOF) {
      printf("Exiting\n");
      break;
    }
    c = (c + 1) % 2;
    if (1 == c) {
      swapcontext(&ctx_main, &ctx_1);
    } else {
      swapcontext(&ctx_main, &ctx_2);
    }
  }

  free(stack1);
  free(stack2);

  return 0;
}
